# Contributing

We love your input! We want to make contributing to this project as easy and
transparent as possible, whether it's:

  - Reporting a bug
  - Discussing the current state of the code
  - Submitting a fix
  - Proposing new features

## We Develop with Github

We use github to host code, to track issues and feature requests, as well as
accept contributions in the form of pull requests.

You start off by creating a fork of goToMain/libosdp to <your-username>/libosdp
and then clone from your fork (or add another remote to existing clone). After
that, you can create a branch from master and make your code changes there and
push your changed to origin (if you added a remote earlier, then to that
remote). Now when you visit github page for <your-username>/libosdp, you should
see an option to raise a pull requst to goToMain/libosdp.

You can read more about github development work flow [here][1] and

## Any contributions you make will be under the project's license

In short, when you submit code changes, your submissions are understood to be
under the same license that covers the project. Feel free to contact the
maintainers if that's a concern.

## Write bug reports with detail, background, and sample code

**Great Bug Reports** tend to have:

  - A quick summary and/or background
  - Steps to reproduce
     * Be specific!
     * Give sample code if you can
  - What you expected would happen
  - What actually happens
  - Notes (possibly including why you think this might be happening, or stuff
    you tried that didn't work)

## Use a Consistent Coding Style

Look around, make your code fit in. We mostly follow the kernel coding style
with minor variations.

[1]: https://guides.github.com/introduction/flow/index.html
